// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function CreateStringMap(){
  var map;

  map = {};

  map.keys = [];
  map.keys.length = 0;
  map.values = [];
  map.values.length = 0;
  map.lengthx = 0;

  return map;
}
function AddToStringMap(map, key, value){
  var exists;
  var i;
  var found;
  var newkeys, newvalues;
  var x;

  exists = {};
  x = GetFromStringMap(map, key, exists);
		
  if(exists.booleanValue){
    found = false;
    for(i = 0; i < map.lengthx &&  !found ; i = i + 1){
      if(StringsEqual(map.keys[i].string, key)){
        map.values[i].string = value;
        found = true;
      }
    }
  }else{
    newkeys = [];
    newkeys.length = map.lengthx + 1;
    newvalues = [];
    newvalues.length = map.lengthx + 1;

    for(i = 0; i < map.lengthx; i = i + 1){
      newkeys[i] = map.keys[i];
      newvalues[i] = map.values[i];
    }
    newkeys[map.lengthx] = {};
    newkeys[map.lengthx].string = key;
    newvalues[map.lengthx] = {};
    newvalues[map.lengthx].string = value;
			
    delete(map.keys);
    delete(map.values);
			
    map.keys = newkeys;
    map.values = newvalues;
    map.lengthx = map.lengthx + 1;
  }
}
function GetFromStringMap(map, key, found){
  var i;
  var value;

  value = "".split('');
  found.booleanValue = false;
		
  for(i = 0; i < map.lengthx &&  !found.booleanValue ; i = i + 1){
    if(StringsEqual(map.keys[i].string, key)){
      value = map.values[i].string;
      found.booleanValue = true;
    }
  }
		
  return value;
}
function RemoveFromStringMap(map, key){
  var found;
  var i;

  found = false;

  for(i = 0; i < map.lengthx &&  !found ; i = i + 1){
    if(StringsEqual(map.keys[i].string, key)){
      map.keys[i] = map.keys[map.lengthx - 1];
      map.values[i] = map.values[map.lengthx - 1];
      map.lengthx = map.lengthx - 1;

      found = true;
    }
  }

  return found;
}
function CreateDecimalMap(){
  var map;

  map = {};
  map.keys = [];
  map.keys.length = 0;
  map.values = [];
  map.values.length = 0;
  map.lengthx = 0;

  return map;
}
function AddToDecimalMap(map, key, value){
  var exists;
  var found;
  var i;
  var newkeys, newvalues;

  exists = {};

  GetFromDecimalMap(map, key, exists);
		
  if(exists.booleanValue){
    found = false;
    for(i = 0; i < map.lengthx &&  !found ; i = i + 1){
      if(map.keys[i] == key){
        map.values[i] = value;
        found = true;
      }
    }
  }else{
    newkeys = [];
    newkeys.length = map.lengthx + 1;
    newvalues = [];
    newvalues.length = map.lengthx + 1;

    for(i = 0; i < map.lengthx; i = i + 1){
      newkeys[i] = map.keys[i];
      newvalues[i] = map.values[i];
    }
    newkeys[map.lengthx] = key;
    newvalues[map.lengthx] = value;
			
    delete(map.keys);
    delete(map.values);
			
    map.keys = newkeys;
    map.values = newvalues;
    map.lengthx = map.lengthx + 1;
  }
}
function GetFromDecimalMap(map, key, found){
  var value, i;

  found.booleanValue = false;
  value = 0;
		
  for(i = 0; i < map.lengthx &&  !found.booleanValue ; i = i + 1){
    if(map.keys[i] == key){
      value = map.values[i];
      found.booleanValue = true;
    }
  }
		
  return value;
}
function RemoveFromDecimalMap(map, key){
  var found;
  var i;

  found = false;

  for(i = 0; i < map.lengthx &&  !found ; i = i + 1){
    if(map.keys[i] == key){
      map.keys[i] = map.keys[map.lengthx - 1];
      map.values[i] = map.values[map.lengthx - 1];
      map.lengthx = map.lengthx - 1;

      found = true;
    }
  }

  return found;
}
function testStringMap(){
  var testresultx;
  var map;
  var i;
  var key, value;
  var found;

  testresultx = {};
  testresultx.failures = 0;

  map = CreateStringMap();

  AddToStringMap(map, "a".split(''), "b".split(''));
  AddToStringMap(map, "c".split(''), "d".split(''));
  AddToStringMap(map, "e".split(''), "f".split(''));
  AddToStringMap(map, "a".split(''), "hei".split(''));

  RemoveFromStringMap(map, "e".split(''));

  if(map.lengthx != 2){
    testresultx.failures = testresultx.failures + 1;
  }

  for(i = 0; i < map.lengthx; i = i + 1){
    key = map.keys[i].string;
    found = {};
    value = GetFromStringMap(map, key, found);
    /* Multiple returns supported with reference types. */
    if(found.booleanValue){
    }else{
      testresultx.failures = testresultx.failures + 1;
    }
  }

  delete(map);
  /* An empty static method named delete signals a delete. */
  return testresultx;
}
function testDecimalMap(){
  var testresultx;
  var map;
  var key;
  var i;
  var value;
  var found;

  testresultx = {};
  testresultx.failures = 0;

  map = CreateDecimalMap();

  AddToDecimalMap(map, 1, 4);
  AddToDecimalMap(map, 2, 5);
  AddToDecimalMap(map, 3, 6);
  AddToDecimalMap(map, 1, 7);

  RemoveFromDecimalMap(map, 3);

  if(map.lengthx != 2){
    testresultx.failures = testresultx.failures + 1;
  }

  for(i = 0; i < map.lengthx; i = i + 1){
    key = map.keys[i];
    found = {};
    value = GetFromDecimalMap(map, key, found);
    /* Multiple returns supported with reference types. */
    if(found.booleanValue){
    }else{
      testresultx.failures = testresultx.failures + 1;
    }
  }

  delete(map);
  /* An empty static method named delete signals a delete. */
  return testresultx;
}
function test(){
  var failures;

  failures = 0;

  failures = failures + test1();
  failures = failures + test2();

  return failures;
}
function test1(){
  var failures;
  var testresult;

  failures = CreateNumberReference(0);

  testresult = testStringMap();
  AssertEquals(testresult.failures, 0, failures);

  return failures.numberValue;
}
function test2(){
  var failures;
  var testresult;

  failures = CreateNumberReference(0);

  testresult = testDecimalMap();
  AssertEquals(testresult.failures, 0, failures);

  return failures.numberValue;
}
function StringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function SwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function ReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    SwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !StringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}


module.exports = {
	CreateStringMap: CreateStringMap,
	AddToStringMap: AddToStringMap,
	GetFromStringMap: GetFromStringMap,
	RemoveFromStringMap: RemoveFromStringMap,
	CreateDecimalMap: CreateDecimalMap,
	AddToDecimalMap: AddToDecimalMap,
	GetFromDecimalMap: GetFromDecimalMap,
	RemoveFromDecimalMap: RemoveFromDecimalMap,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayRange: FillNumberArrayRange,
	FillBooleanArrayRange: FillBooleanArrayRange,
	FillStringRange: FillStringRange,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SwapElementsOfNumberArray: SwapElementsOfNumberArray,
	SwapElementsOfStringArray: SwapElementsOfStringArray,
	ReverseNumberArray: ReverseNumberArray,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	test: test
};